{ Direktes Ansteuern eines einzelnen Motors }
procedure debug_menue_motor_direkt (txt : string;motoradresse,pos : byte);
var ende  : boolean;
    ch    : char;
    steps : word;
 begin

  ende:=false;
  repeat
   writeln (#10#13,'Motorsteuerung ',txt,' Position : ',schrittpos [pos],#10#13);
   writeln ('1. Referenzposition anfahren');
   writeln ('2. n Schritte vorwrts');
   writeln ('3. n Schritte rckwrts');

   repeat
    ch:=readkey;
   until ( (ch in ['1'..'3']) or (ch=#27) );

   case ch of
    '1' : begin
           schrittpos [pos]:=0;
           if motor_go_ref (motoradresse) then writeln ('Referenzposition gefunden')
            else writeln ('Motorfehler');
          end;

    '2' : begin
           write ('Anzahl Vorwrtschritte : ');read (steps);
           schrittpos [pos]:=schrittpos [pos]+steps;
           if motor_step_forward (motoradresse,steps) then writeln ('Schrittposition erreicht')
            else writeln ('Motorfehler');
          end;

    '3' : begin
           write ('Anzahl Rckwrtschritte : ');read (steps);
           schrittpos [pos]:=schrittpos [pos]-steps;
           if motor_step_back (motoradresse,steps) then writeln ('Schrittposition erreicht')
            else writeln ('Motorfehler'); 
          end;

   end; { Von Case }

   ende:=(ch=#27);
  until ende;

 end;

{ Debugfunktionen zur direkten Steuerung der Motoren }
procedure debug_menue_motoren;
var ende : boolean;
    ch   : char;
 begin

  ende:=false;
  repeat
   writeln (#10#13,'Motormen'#10#13);
   if heber then writeln ('1. Heber');
   if schwenker then writeln ('2. Schwenker');
   if teller then writeln ('3. Teller');
   if dreher then writeln ('4. Dreher');
   if greifer then writeln ('5. Greifer');

   repeat
    ch:=readkey;
   until ( (ch in ['1'..'5']) or (ch=#27) );

   case ch of
    '1' : if heber     then debug_menue_motor_direkt ('Heber',adress_heber,1);
    '2' : if schwenker then debug_menue_motor_direkt ('Schwenker',adress_schwenker,2);
    '3' : if teller    then debug_menue_motor_direkt ('Teller',adress_Teller,3);
    '4' : if dreher    then debug_menue_motor_direkt ('Dreher',adress_dreher,4);
    '5' : if greifer   then debug_menue_motor_direkt ('Heber',adress_greifer,5);
   end; { Von Case }

   ende:=(ch=#27);
  until ende;

 end;

{ Debugfunktionen zur direkten Steuerung einer Lampe }
procedure debug_menue_lampen_direkt (txt : string;lampenadresse : byte);
var ende            : boolean;
    ch              : char;
    start,stop,zeit : byte;
 begin

  ende:=false;
  repeat
   writeln (#10#13,'Lampensteuerung ',txt,#10#13);
   writeln ('1. Lampe direkt ansteuern');
   writeln ('2. Lampe absolut dimmen');
   writeln ('3. Lampe relativ dimmen');

   repeat
    ch:=readkey;
   until ( (ch in ['1'..'3']) or (ch=#27) );

   case ch of
    '1' : begin
           write ('Lampenwert : ');read (start);
           if lamp_switch (lampenadresse,start) then writeln ('Lampe angesteuert')
            else writeln ('Lampenfehler');
          end;

    '2' : begin
           write ('Startwert : ');read (start);
           write ('Endwert : ');read (stop);
           write ('Zeit : ');read (zeit);
           if lamp_dimm_absolut (lampenadresse,start,stop,zeit) then writeln ('Lampe angesteuert')
            else writeln ('Lampenfehler');
          end;

    '3' : begin
           write ('Endwert : ');read (start);
           write ('Zeit : ');read (zeit);
           if lamp_dimm_relative (lampenadresse,stop,zeit) then writeln ('Lampe angesteuert')
            else writeln ('Lampenfehler');
          end;

   end; { Von Case }

   ende:=(ch=#27);
  until ende;

 end;

{ Debugfunktionen zur direkten Steuerung der Lampen }
procedure debug_menue_lampen;
var ende : boolean;
    ch   : char;
 begin

 ende:=false;
  repeat
   writeln (#10#13,'Lampenmen'#10#13);
   if lampe_oben_rechts then writeln ('1. Lampe oben rechts');
   if lampe_oben_links then writeln ('2. Lampe oben links');
   if lampe_mischer_rot then writeln ('3. Mischerlampe rot');
   if lampe_mischer_gruen then writeln ('4. Mischerlampe gruen');
   if lampe_mischer_blau then writeln ('5. Mischerlampe blau');
   if lampe_mischer_gelb then writeln ('6. Mischerlampe gelb');

   repeat
    ch:=readkey;
   until ( (ch in ['1'..'6']) or (ch=#27) );

   case ch of
    '1' : if Lampe_oben_rechts then
           debug_menue_lampen_direkt ('Lampe oben rechts',adress_lampe_top_right);
    '2' : if Lampe_oben_links  then
           debug_menue_lampen_direkt ('Lampe oben links',adress_lampe_top_left);
    '3' : if Lampe_mischer_rot then
           debug_menue_lampen_direkt ('Lampe Mischer rot',adress_mischer_rot);
    '4' : if Lampe_mischer_gruen then
           debug_menue_lampen_direkt ('Lampe Mischer gruen',adress_mischer_gruen);
    '5' : { if Lampe_mischer_blau then }
           debug_menue_lampen_direkt ('Lampe Mischer blau',adress_mischer_blau);
    '6' : if Lampe_mischer_gelb then
           debug_menue_lampen_direkt ('Lampe Mischer gelb',adress_mischer_gelb);

   end; { Von Case }

   ende:=(ch=#27);
  until ende;

 end;

{ Debugfunktionen zur direkten Steuerung der Displays }
procedure debug_menue_displays;
var ende            : boolean;
    ch              : char;
    wertstr         : string;
    wert            : byte;
    zeile           : byte;
    spalte          : byte;
    cursan,curblink : boolean;
    can,cblink      : byte;

 begin

 ende:=false;
 repeat;
  writeln (#10#13,'Displaymen'#10#13);
   writeln ('1. Licht ein');
   writeln ('2. Licht aus');
   writeln ('3. Zeichen ausgeben');
   writeln ('4. Kommando ausgeben');
   writeln ('5. Speicher fllen/anzeigen');
   writeln ('6. Display lschen');
   writeln ('7. Cursor ein/aus');
   writeln ('8. Cursor setzen');

   repeat
    ch:=readkey;
   until ( (ch in ['1'..'8']) or (ch=#27) );

   case ch of
    '1' : if display_light (1) then writeln ('Display Licht ein')
            else writeln ('Displayfehler');
    '2' : if display_light (0) then writeln ('Display Licht aus')
            else writeln ('Displayfehler');
    '3' : begin
           write ('Zeile (0/1) : ');readln (zeile);
           write ('Zeichenkette : ');readln (wertstr);
           if  (write_char_display_big (zeile,wertstr)) then writeln ('Display angesteuert')
            else writeln ('Displayfehler');
          end;
    '4' : begin
           write ('Zeile (0/1) : ');read (zeile);
           write ('Kommando : ');read (wert);
           if  (write_command_display_big (zeile,wert)) then writeln ('Display angesteuert')
            else writeln ('Displayfehler');
          end;
    '5' : begin
           write ('Zeile (0..3) : ');readln (zeile);
           write ('Spalte (0..39) : ');readln (spalte);
           write ('Text : ');readln (wertstr);
           big_display_buffer_write (spalte,zeile,wertstr);
           big_display_refresh;
          end;
    '6' : begin
           big_display_clear;
           writeln ('Display gelscht');
          end;
    '7' : begin
           write ('Zeile (0/1) : ');readln (zeile);
           write ('Cursor an (0/1) : ');readln (can);
           write ('Blinken an (0/1) : ');readln (cblink);
           cursan:=(can<>0);
           curblink:=(cblink<>0);
           big_display_cursor (zeile,cursan,curblink);
           writeln ('Cursor gesetzt');
          end;
    '8' : begin
           write ('Zeile (0..3) : ');readln (zeile);
           write ('Spalte (0..39) : ');readln (spalte);
           set_cursor_display_big (spalte,zeile);
           writeln ('Cursor gesetzt');
          end;




   end; { Von Case }

   ende:=(ch=#27);
  until ende;

 end;

{ Debugfunktionen zur direkten Steuerung der IO-Funktionen }
procedure debug_menue_io;
var ende            : boolean;
    ch              : char;
    wertstr         : string;
    wert            : byte;
    zeile           : byte;
    spalte          : byte;
    cursan,curblink : boolean;
    can,cblink      : byte;

 begin

 ende:=false;
 repeat;
  writeln (#10#13,'IO-Men'#10#13);
   writeln ('1. Licht schalten');
   writeln ('2. Bewegungsmelder auslesen');

   repeat
    ch:=readkey;
   until ( (ch in ['1'..'2']) or (ch=#27) );

   case ch of
    '1' : begin
           write ('Wert (0..255) : ');readln (zeile);
           if  (write_char_io (zeile)) then writeln ('IO angesteuert')
            else writeln ('IO-fehler');
          end;
    '2' : begin
           if io_getchar then writeln ('IO gelesen')
            else writeln ('IO-fehler');
            writeln ('Empfangenes Zeichen : ',keyboard_key);
          end;

   end; { Von Case }

   ende:=(ch=#27);
  until ende;

 end;


{ Debugfunktionen zur direkten Steuerung des Keyboards }
procedure  debug_menue_keyboard;
var ende            : boolean;
    ch              : char;
    wertstr         : string;
    wert            : byte;
    zeile           : byte;
    spalte          : byte;
    cursan,curblink : boolean;
    can,cblink      : byte;

 begin

 ende:=false;
 repeat;
  writeln (#10#13,'Keyboardmen'#10#13);
   writeln ('1. Licht');
   writeln ('2. Flush');
   writeln ('3. Lock/Unlock');
   writeln ('4. Read');

   repeat
    ch:=readkey;
   until ( (ch in ['1'..'4']) or (ch=#27) );

   case ch of
    '1' : begin
            write ('Licht (0..3) : ');readln (wert);
            if keyboard_light (wert) then writeln ('Keyboard Licht geschaltet')
            else writeln ('Keyboardfehler');
          end;
    '2' : begin
           if keyboard_flush then writeln ('Keyboard Puffer leer')
            else writeln ('Keyboardfehler');
          end;
    '3' : begin
            write ('Lock (0/1) : ');readln (wert);
            if keyboard_light (wert) then writeln ('Keyboard Lock geschaltet')
            else writeln ('Keyboardfehler');
          end;
    '4' : begin
           if keyboard_getchar then writeln ('Keyboard gelesen')
            else writeln ('Keyboardfehler');
            writeln ('Empfangenes Zeichen : ',keyboard_key);
          end;

   end; { Von Case }

   ende:=(ch=#27);
  until ende;


(*  keyboard_light (x : byte)
  function keyboard_light (x : byte) : boolean;
  function keyboard_getchar : boolean;
  function keyboard_lock (x : byte) : boolean;
  function keyboard_flush : boolean;
  *)
 end;

{ Debugfunktionen zur direkten Steuerung der CD-Funktionen }
procedure debug_meue_cd;
var ende : boolean;
    zaehler : byte;
 begin

  ende:=false;
  repeat
   writeln (#10#13,'Cd-Steuerung ',#10#13);
   writeln ('1. Schublade ffnen');
   writeln ('2. Schublade schliessen');
   writeln ('3. Laufwerkstatus');
   writeln ('4. CD starten');
   writeln ('5. CD stoppen');
   writeln ('6. Skip +');
   writeln ('7. Skip -');
   writeln ('8. Laufzeitinfo');
   writeln ('9. Tracksinfo');

   repeat
    ch:=readkey;
   until ( (ch in ['1'..'9']) or (ch=#27) );

   case ch of
    '1' : cd_open;
    '2' : cd_close;
    '3' : begin
           cd_get_status;
           writeln ('Tr offen : ',tuer_offen);
           writeln ('CD eingelegt : ',cd_eingelegt);
           writeln ('Typ Audio : ',cd_typ_audio);
           writeln ('CD luft : ',wiedergabe_laeuft);
          end;
    '4' : cd_play;
    '5' : cd_stop;
    '6' : cd_skip_forward;
    '7' : cd_skip_back;
    '8' : begin
           cd_get_time;
           writeln ('Aktueller Track : ',aktueller_track);
           writeln ('Aktueller Index : ',aktueller_index);
           writeln ('Minuten : ',aktuelle_minute);
           writeln ('Sekunden : ',aktuelle_sekunde);
          end;
    '9' : begin
           cd_get_info;
           writeln ('Titel : Laufzeit');
           for zaehler:=1 to trackanzahl do
            writeln (trackinfo [zaehler].number,' ',trackinfo [zaehler].min,':',trackinfo [zaehler].sec);
         end;

   end; { Von Case }

   ende:=(ch=#27);
  until ende;

 end;

{ Debugfunktionen zur direkten Steuerung }
procedure debug_menue;
var ende : boolean;
    ch   : char;
 begin

  ende:=false;
  repeat
   writeln (#10#13,'Haupt-Debugmen'#10#13);
   if motoren then writeln ('1. Motorfunktionen');
   if lampen then writeln ('2. Lampenfunktionen');
   if displays then writeln ('3. Displayfunktionen');
   if io then writeln ('4. IO-Funktionen');
   writeln ('5. CD-Steuerung');
   if keyboards then writeln ('6. Keyboard-Funktionen');
   if ios then writeln ('7. IO-Funktionen');
   repeat
    ch:=readkey;
   until ( (ch in ['1'..'7']) or (ch=#27) );

   case ch of
    '1' : if motoren then debug_menue_motoren;
    '2' : if lampen then debug_menue_lampen;
    '3' : if displays then debug_menue_displays;
    '4' : if io then debug_menue_io;
    '5' : debug_meue_cd;
    '6' : if keyboard then debug_menue_keyboard;
    '7' : if io then debug_menue_io;

   end; { Von Case }

   ende:=(ch=#27);
  until ende;
 end;
