
{ Keyboard identifizieren }
function keyboard_identify (adress : byte) : boolean;
 begin
  write_sio_status (adress);    { Adresse der Lampe senden }
  write_sio_status (k_identify);{ Befehl senden }
  write_sio_status ($00);       { Es folgen keine Parameter }

  write_sio_status ($02);       { Es mssen zwei Bytes zurckkommen }

  { Warten auf das Acknowledge vom keyboard }
  keyboard_identify:=get_acknowledge (adress,k_identify,0);
 end;


{ Schaltet die Lampen im Keyboard (0..2) }
function keyboard_light (x : byte) : boolean;
 begin
  write_sio_status (adress_keyboard);    { Adresse senden }
  write_sio_status (k_light);            { Befehl senden }
  write_sio_status ($01);                { Es folgen Parameter }
  write_sio_status (x);                { Es folgen Parameter }

  write_sio_status ($02);       { Es mssen zwei Bytes zurckkommen }

  { Warten auf das Acknowledge vom keyboard }
  rescon:=false;
  keyboard_light:=get_acknowledge (adress_keyboard,k_light,0);
  rescon:=true;
 end;

{ Liefert Tasten zurck }
function keyboard_getchar : boolean;
 begin
  write_sio_status (adress_keyboard);    { Adresse senden }
  write_sio_status (k_getchar);            { Befehl senden }
  write_sio_status ($00);                { Es folgen Parameter }

  write_sio_status ($02);       { Es mssen zwei Bytes zurckkommen }

  { Warten auf das Acknowledge vom keyboard }
  rescon:=false;
  keyboard_getchar:=get_acknowledge (adress_keyboard,k_getchar,0);
  rescon:=true;

  { Die eventuelle Taste steht jetzt in der Variable "keyboard" }
 end;


{ Sperrt die Tastatur (0..1) }
function keyboard_lock (x : byte) : boolean;
 begin
  write_sio_status (adress_keyboard);    { Adresse senden }
  write_sio_status (k_lock);            { Befehl senden }
  write_sio_status ($01);                { Es folgen Parameter }
  write_sio_status (x);                { Es folgen Parameter }

  write_sio_status ($02);       { Es mssen zwei Bytes zurckkommen }

  { Warten auf das Acknowledge vom keyboard }
  keyboard_lock:=get_acknowledge (adress_keyboard,k_lock,0);
 end;


{ Leert den Puffer }
function keyboard_flush : boolean;
 begin
  write_sio_status (adress_keyboard);    { Adresse senden }
  write_sio_status (k_flush);            { Befehl senden }
  write_sio_status ($00);                { Es folgen keine Parameter }

  write_sio_status ($02);       { Es mssen zwei Bytes zurckkommen }

  { Warten auf das Acknowledge vom keyboard }
  keyboard_flush:=get_acknowledge (adress_keyboard,k_flush,0);


 end;
