{ Referenzposition anfahren }
function motor_go_ref (adress : byte) : boolean;
 begin

  write_sio_status (adress);     { Adresse des Motors senden }
  write_sio_status (m_goref); { Befehl senden }
  write_sio_status ($00);        { Es folgen keine Parameter }
  write_sio_status ($02);        { Es mssen zwei Bytes zurckkommen }

  { Warten auf das Acknowledge vom Motor }
  motor_go_ref:=get_acknowledge (adress,m_goref,1);

 end;

{ steps Schritte vorfahren }
function motor_step_forward (adress : byte;steps : word) : boolean;
 begin

  write_sio_status (adress);       { Adresse des Motors senden }
  write_sio_status (m_stepforward);{ Befehl senden }
  write_sio_status ($02);          { Es folgen zwei Parameter }
  write_sio_status (hi (steps));   { Highbyte von Steps }
  write_sio_status (lo (steps));   { Lowbyte von Steps }
  write_sio_status ($02);          { Es mssen zwei Bytes zurckkommen }

  { Warten auf das Acknowledge vom Motor }
  motor_step_forward:=get_acknowledge (adress,m_stepforward,1);

 end;

{ steps Schritte zurckfahren }
function motor_step_back (adress : byte;steps : word) : boolean;
 begin
  write_sio_status (adress);       { Adresse des Motors senden }
  write_sio_status (m_stepback);   { Befehl senden }
  write_sio_status ($02);          { Es folgen zwei Parameter }
  write_sio_status (hi (steps));   { Highbyte von Steps }
  write_sio_status (lo (steps));   { Lowbyte von Steps }
  write_sio_status ($02);          { Es mssen zwei Bytes zurckkommen }

  { Warten auf das Acknowledge vom Motor }
  motor_step_back:=get_acknowledge (adress,m_stepback,1);

 end;

{ Motor identifizieren }
function motor_identify (adress : byte) : boolean;
 begin

  write_sio_status (adress);     { Adresse des Motors senden }
  write_sio_status (m_identify); { Befehl senden }
  write_sio_status ($00);        { Es folgen keine Parameter }
  write_sio_status ($02);        { Es mssen zwei Bytes zurckkommen }

  { Warten auf das Acknowledge vom Motor }
  motor_identify:=get_acknowledge (adress,m_identify,0);

 end;
