{--------------------------------}
{ Macht die Show mit dem Mischer }
{--------------------------------}
procedure do_the_show (art : byte);
var grenze : integer;
 begin
  if art=0 then grenze:=300 else grenze:=4;

  inc (durchlauf);

  if durchlauf>grenze then
   begin
    durchlauf:=0;

    case showcount of
     0 : begin
          lamp_dimm_absolut (adress_mischer_rot,100,0,3);
          lamp_dimm_absolut (adress_mischer_gruen,100,0,3);
          lamp_dimm_absolut (adress_mischer_gelb,0,100,3);
          lamp_dimm_absolut (adress_mischer_blau,0,100,3);
         end;
     1 : begin { Gruen aus, blau ein }
          lamp_dimm_absolut (adress_mischer_rot,0,100,3);
          lamp_dimm_absolut (adress_mischer_gelb,100,0,3);
         end;
     2 : begin { Blau aus, rot ein }
          lamp_dimm_absolut (adress_mischer_gruen,0,100,3);
          lamp_dimm_absolut (adress_mischer_rot,100,0,3);
         end;
     3 : begin  { Gruen ein, Gelb aus rot ein }
          lamp_dimm_absolut (adress_mischer_rot,0,100,3);
          lamp_dimm_absolut (adress_mischer_blau,100,0,3);
         end;
    end; { Von Case }

    if showcount<3 then inc (showcount) else showcount:=0;
   end;

 end;

{----------------------------}
{ Zahl von Tastatur einlesen }
{----------------------------}
function get_cd_number (cx,cy : byte) : byte;
var numende : boolean;
    cursx,cursy : byte;
    zahl1,zahl2 : char;
    keyboard_keybuf : byte;
    retbuf : byte;
 begin
  cursx:=cx;
  cursy:=cy;
  zahl1:=' ';
  zahl2:=' ';
  { Cursor an Positiom setzen                 }
  set_cursor_display_big (cx,cy);
  { Cursor blinken lassen, Cursor einschalten }
  big_display_cursor (1,true,true);

  { Puffer leeren }
  if keyboard_flush then writeln ('Keyboard Puffer leer')
   else writeln ('Keyboardfehler');

  { Zahl eingeben }
  numende:=false;
  repeat
   if keyboard_getchar then
    begin
      keyboard_keybuf:=keyboard_key;
      case keyboard_key of
       112 : begin { 1 }
              if cursx=cx then zahl1:='1' else zahl2:='1';
              big_display_buffer_write (cursx,cursy,'1');
              if cursx=cx then inc (cursx);
              keyboard_flush;
            end;
       128 : begin { 2 }
              if cursx=cx then zahl1:='2' else zahl2:='2';
              big_display_buffer_write (cursx,cursy,'2');
              if cursx=cx then inc (cursx);
              keyboard_flush;
             end;
       144 : begin { 3 }
              if cursx=cx then zahl1:='3' else zahl2:='3';
              big_display_buffer_write (cursx,cursy,'3');
              if cursx=cx then inc (cursx);
              keyboard_flush;
             end;
       160 : begin { 4 }
              if cursx=cx then zahl1:='4' else zahl2:='4';
              big_display_buffer_write (cursx,cursy,'4');
              if cursx=cx then inc (cursx);
              keyboard_flush;
             end;
       176 : begin { 5 }
              if cursx=cx then zahl1:='5' else zahl2:='5';
              big_display_buffer_write (cursx,cursy,'5');
              if cursx=cx then inc (cursx);
              keyboard_flush;
             end;
       96 : begin { 6 }
              if cursx=cx then zahl1:='6' else zahl2:='6';
              big_display_buffer_write (cursx,cursy,'6');
              if cursx=cx then inc (cursx);
              keyboard_flush;
             end;
       80 : begin { 7 }
              if cursx=cx then zahl1:='7' else zahl2:='7';
              big_display_buffer_write (cursx,cursy,'7');
              if cursx=cx then inc (cursx);
              keyboard_flush;
             end;
       64 : begin { 8 }
              if cursx=cx then zahl1:='8' else zahl2:='8';
              big_display_buffer_write (cursx,cursy,'8');
              if cursx=cx then inc (cursx);
              keyboard_flush;
             end;
       48 : begin { 9 }
              if cursx=cx then zahl1:='9' else zahl2:='9';
              big_display_buffer_write (cursx,cursy,'9');
              if cursx=cx then inc (cursx);
              keyboard_flush;
             end;
       32 : begin { 0 }
              if cursx=cx then zahl1:='0' else zahl2:='0';
              big_display_buffer_write (cursx,cursy,'0');
              if cursx=cx then inc (cursx);
              keyboard_flush;
             end;
       192 : begin { OK }
              keyboard_flush;
             end;
       16 : begin { Back }
              if cursx>cx then { 2. Zeichen }
               begin
                big_display_buffer_write (cursx,cursy,' ');
                zahl2:=' ';
                dec (cursx);
                keyboard_key:=0;
               end else
               begin
                zahl1:=' ';
                big_display_buffer_write (cursx,cursy,' ');
               end;
              keyboard_flush;
             end;

    end; { Von Case.... }

    if (keyboard_keybuf in [112,128,144,160,176,192,96,80,64,48,32,16]) then
     begin
       big_display_refresh; { Text ausgeben }
       set_cursor_display_big (cursx,cy);
     end;

   if (keyboard_keybuf in [192,16]) then numende:=true; { Und schluss }

   

  end; { Von if }

  until numende;

  if keyboard_keybuf=16 then get_cd_number:=0 else { Keine Auswahl }
   begin
    retbuf:=0;
    if (zahl1<>' ') and (zahl2=' ') then retbuf:=retbuf+ord (zahl1)-48 else
     retbuf:=retbuf+(ord (zahl1)-48)*10+(ord (zahl2)-48);
    get_cd_number:=retbuf;
   end;
  { Cursor abschalten }

  big_display_cursor (1,false,false);

  writeln ('Eingabe beendet, Zahl ',retbuf);
  keyboard_flush;
 end;

{----------------------------------------------}
{ Steuerung, solgange keine CD im Laufwerk ist }
{----------------------------------------------}
procedure no_cd;
 begin
  { Seitenlicht animiert einschalten }
  write_char_io (7);
  delay (300);
  write_char_io (24+7);
  delay (300);
  write_char_io (96+24+7);
  delay (300);
  write_char_io (255);

  cd_get_status;

  { Mentext ausgeben }
  big_display_clear;
  big_display_buffer_write (12,0,'Keine CD eingelegt');
  big_display_buffer_write (6,1,'1 : CD einlegen');
  if tuer_offen then
   big_display_buffer_write (6,2,'2 : Schublade schliessen    ') else
   big_display_buffer_write (6,2,'2 : Schublade oeffnen        ');

  display_light (1);   { Licht einschalten }
  big_display_refresh; { Text ausgeben }

  { Puffer leeren }
  if keyboard_flush then writeln ('Keyboard Puffer leer')
   else writeln ('Keyboardfehler');

  
  while not cd_eingelegt do
   begin
    if keypressed then pc_key:=readkey;
    if pc_key<>#0 then exit;

    do_the_show (0);

    if keyboard_getchar then
    case keyboard_key of
     112 : begin { 1 CD einlegen }
            big_display_buffer_write (6,2,'      CD Nummer :           ');
              { Puffer leeren }
              if keyboard_flush then writeln ('Keyboard Puffer leer')
               else writeln ('Keyboardfehler');

            big_display_refresh; { Text ausgeben }
            CD_Nummer:=get_cd_number (24,2);
            if cd_nummer in [1..12] then
             begin
              big_display_clear;
              big_display_buffer_write (14,1,'CD einlegen');
              big_display_buffer_write (13,2,'Bitte warten');
              big_display_refresh; { Text ausgeben }
              writeln ('CD einlegen...');
              steuerung_cd_einlegen (cd_nummer);

              cd_get_status;
              if cd_eingelegt then  exit else { Jetzt liegt eine drin.... }
               begin { Fehler anzeigen }
                big_display_clear;
                big_display_buffer_write (11,1,'Keine CD gefunden');
                big_display_buffer_write (14,2,'OK druecken');
                big_display_refresh;

                if keyboard_flush then writeln ('Keyboard Puffer leer')
                 else writeln ('Keyboardfehler');

                repeat
                 keyboard_getchar;
                until keyboard_key<>0;

                { Puffer leeren }
                if keyboard_flush then writeln ('Keyboard Puffer leer')
                 else writeln ('Keyboardfehler');

                { Men restaurieren }
                big_display_clear;
                big_display_buffer_write (12,0,'Keine CD eingelegt');
                big_display_buffer_write (6,1,'1 : CD einlegen');
               if tuer_offen then
                big_display_buffer_write (6,2,'2 : Schublade schliessen    ') else
                big_display_buffer_write (6,2,'2 : Schublade oeffnen        ');
               display_light (1);   { Licht einschalten }
               big_display_refresh; { Text ausgeben }

               end;

             end else
             begin
              { Mentext ausgeben }
              big_display_clear;
              big_display_buffer_write (12,0,'Keine CD eingelegt');
              big_display_buffer_write (6,1,'1 : CD einlegen');
              if tuer_offen then
               big_display_buffer_write (6,2,'2 : Schublade schliessen    ') else
               big_display_buffer_write (6,2,'2 : Schublade oeffnen        ');
              display_light (1);   { Licht einschalten }
              big_display_refresh; { Text ausgeben }
             end;

           end;
     128 : begin { 2 }
             { Puffer leeren }
               if keyboard_flush then writeln ('Keyboard Puffer leer')
                 else writeln ('Keyboardfehler');
             big_display_buffer_write (13,3,'Bitte warten');
             big_display_refresh; { Text ausgeben }
             if tuer_offen then
              begin
               cd_close;
               big_display_buffer_write (6,2,'2 : Schublade oeffnen        ');
               big_display_refresh; { Text ausgeben }
              end else
              begin
               cd_open;
               big_display_buffer_write (6,2,'2 : Schublade schliessen    ');
               big_display_refresh; { Text ausgeben }
              end;
             cd_get_status;
             big_display_buffer_write (13,3,'            ');
             big_display_refresh; { Text ausgeben }
             { Puffer leeren }
             if keyboard_flush then writeln ('Keyboard Puffer leer')
              else writeln ('Keyboardfehler');
           end;
    end;  { Von Case }

   end; { if keyboard_getchar then }

 end;

{------------------------}
{ Wiedergabeme ausgeben }
{------------------------}
procedure docd_menue;
var dummystring : string;
 begin
  
  cd_get_status;
  { display_light (0); }

  { Erste Zeile CD-Nummer anzeigen }
  big_display_buffer_write (13,0,'CD Nummer');
  str (cd_nummer:2,dummystring);
  big_display_buffer_write (23,0,dummystring);

  if not wiedergabe_laeuft then
   repeat { So lange auslesen, bis zweimal das gleiche kommt... }
    temp_wiedergabe_laeuft:=wiedergabe_laeuft;
    cd_get_status;
   until temp_wiedergabe_laeuft=wiedergabe_laeuft;

  { Stimmt die Angabe wirklich ? }
{  if wiedergabe_laeuft<>temp_wiedergabe_laeuft then
   wiedergabe_laeuft:=temp_wiedergabe_laeuft else
 }

  if not wiedergabe_laeuft then
   big_display_buffer_write (26,0,'(stop)') else
   big_display_buffer_write (26,0,'(play)');

  { Dann folgen bedienungshinweise }
  big_display_buffer_write (2,1,'1 Play   2 Stop   3 Skip+   4 Skip-');

  big_display_buffer_write (2,2,'5 Auswerfen       6 Modus :');

  { Wiedergabemodus ausgeben }
  case cd_modus of
   1 : big_display_buffer_write (30,2,'Normal   '); { single }
   2 : big_display_buffer_write (30,2,'CD-Repeat');{ CD-Repeat }
   3 : big_display_buffer_write (30,2,'Wechseln ');{ All-Repeat }
  end;

  { In der letzten Zeile stehen dann die aktuellen Daten }
  big_display_buffer_write (3,3,'Track    /    Zeit   :   min');

  cd_get_info;
  cd_get_time;

  { Gesamte Trackanzahl }
  str (trackanzahl:2,dummystring);
  if dummystring [1]=' ' then dummystring [1]:='0';
  big_display_buffer_write (13,3,dummystring);

  { Stimmt die Angabe wirklich ?
  if wiedergabe_laeuft<>temp_wiedergabe_laeuft then
   wiedergabe_laeuft:=temp_wiedergabe_laeuft else
  temp_wiedergabe_laeuft:=wiedergabe_laeuft; }

  cd_get_time;

  { Aktueller Track }
  if not wiedergabe_laeuft then
   begin
    aktueller_track:=0;
    dummystring:='00';
   end else
  str (aktueller_track:2,dummystring);

  if dummystring [1]=' ' then dummystring [1]:='0';
  big_display_buffer_write (10,3,dummystring);

 { Gesamtspielzeit des Titels }
 minuten_gesamt:=0;
 sekunden_gesamt:=0;

 if aktueller_track<>0 then
  begin
   minuten_gesamt:=trackinfo [aktueller_track].min;
   sekunden_gesamt:=trackinfo [aktueller_track].sec;
  end;
  str (minuten_gesamt:2,dummystring);
  if dummystring [1]=' ' then dummystring [1]:='0';
  big_display_buffer_write (22,3,dummystring+':');
  str (sekunden_gesamt:2,dummystring);
  if dummystring [1]=' ' then dummystring [1]:='0';
  big_display_buffer_write (25,3,dummystring);

  big_display_refresh; { Text ausgeben }
  
  writeln;
  writeln ('Wiedergabe : ',wiedergabe_laeuft);
  writeln ('Track : ',aktueller_track);
  writeln ('Zeit : ',aktuelle_minute,' min ',aktuelle_sekunde,' sec      ');

 end;

{----------------------------------------------------------}
{ Steuerung, solgange CD im Laufwerk                       }
{                                                          }
{ Bedienung wenn CD im Laufwerk ist :                      }
{                                                          }
{ Taste Funktion                                           }
{                                                          }
{ 1     Play/Pause                                         }
{ 2     Stop                                               }
{ 3     Skip+                                              }
{ 4     Skip-                                              }
{ 5     CD auswerfen                                       }
{ 6     Modus ( Normal, CD wiederholen, Rundum wiederholen }
{                                                          }
{----------------------------------------------------------}
procedure do_cd;
var keyboard_keybuf : byte;
 begin

   temp_wiedergabe_laeuft:=false;
   benutzer_modus:=false; { CD luft noch nicht }
   cd_ende:=false;

  display_light (0);   { Licht ausschalten }
  big_display_clear;
  docd_menue;          { Men ausgeben }
  display_light (1);   { Licht einschalten }

  repeat

  do_the_show (1);

  { Tastaturabfrage }
   if keyboard_getchar then
    begin
      keyboard_keybuf:=keyboard_key;
      case keyboard_key of
       112 : begin { 1 Play }
              cd_play;
              writeln ('Wiedergabe luft....');
              temp_wiedergabe_laeuft:=true;
              keyboard_flush;
              benutzer_modus:=true; { Wiedergabe luft }
            end;
       128 : begin { 2 Stop }
              cd_stop;
              writeln ('Wiedergabe angehalten....');
              temp_wiedergabe_laeuft:=false;
              keyboard_flush;
              benutzer_modus:=false; { Wiedergabe angehalten }
             end;
       144 : begin { 3 Skip +}
              cd_skip_forward;
              keyboard_flush;
             end;
       160 : begin { 4 Skip- }
              cd_skip_back;
              keyboard_flush;
             end;
       176 : begin { 5 Auswerfen }
              benutzer_modus:=false; { Wiedergabe angehalten }
              keyboard_flush;
              big_display_clear;
              big_display_buffer_write (14,1,'CD auswerfen');
              big_display_buffer_write (14,2,'Bitte warten');
              big_display_refresh; { Text ausgeben }
              writeln ('CD herausnehmen...');
              steuerung_cd_herausnehmen (cd_nummer);
              delay (5000);
              writeln ('Herausnehmen beendet...');
              cd_get_status;
              { exit;  Verlassen wir diesen trostlosen Ort... }
             end;
       96 : begin { 6 Modus ndern }
              keyboard_flush;
              if cd_modus<3 then inc (cd_modus) else cd_modus:=1;
             end;

    end; { Von Case....  }

   end; { Von if... }

     { Display aktualisieren }
    if cd_eingelegt then docd_menue;

    {-----------------------------------------}
    { Je nach Modus gewisse Dinge veranlassen }
    { Modus=1 : single                        }
    { Modus=2 : CD-Repeat                     }
    { Modus=3 : All-Repeat                    }
    {-----------------------------------------}
    if benutzer_modus=true then
     begin

      { Single }
      if (cd_modus=1) and (wiedergabe_laeuft=false) then
       benutzer_modus:=false;

      { Repeat }
      if (cd_modus=2) and (wiedergabe_laeuft=false) then
       begin { CD neu starten }
       cd_play;
       writeln ('Wiedergabe neu gestartet (Repeat)');
       temp_wiedergabe_laeuft:=true;
       end; { Von CD neu starten }

      { CD turnaround }
      if (cd_modus=3) and (wiedergabe_laeuft=false) then
       begin { nchste CD einlegen und wiedergeben }
        writeln ('Nchste CD einlegen');

        { alte CD herausnehmen }
        big_display_clear;
        big_display_buffer_write (14,1,'CD wechseln');
        big_display_buffer_write (6,2,'Bitte warten ( <- Abbruch )');
        big_display_refresh; { Text ausgeben }

        writeln ('CD herausnehmen...');
        steuerung_cd_herausnehmen (cd_nummer);

        { Tastatur abfragen }
        if keyboard_getchar then
         begin
           keyboard_keybuf:=keyboard_key;
           if keyboard_keybuf=16 then cd_ende:=true;
           if keyboard_flush then writeln ('Keyboard Puffer leer')
            else writeln ('Keyboardfehler');
         end;

        writeln ('Herausnehmen beendet...');

        { nchste CD einlegen und abspielem }
       if not cd_ende then
        begin
         repeat { So lange suchen,. bis wieder eine drinliegt }
          if cd_nummer<12 then inc (cd_nummer) else cd_nummer:=1;
          writeln ('CD Nummer ',cd_nummer,' einlegen...');
          steuerung_cd_einlegen (cd_nummer);
          writeln ('CD Nummer ',cd_nummer,' eingelegt in Essig');
          writeln ('Abspielen');
          cd_play;
          delay (1000);

           { Tastatur abfragen }
           if keyboard_getchar then
            begin
              keyboard_keybuf:=keyboard_key;
              if keyboard_keybuf=16 then cd_ende:=true;
              if keyboard_flush then writeln ('Keyboard Puffer leer')
               else writeln ('Keyboardfehler');
            end;

          cd_get_status;
         until (cd_eingelegt) or (cd_ende);
        end; { Von if not cd_ende then }

        big_display_clear;

       end; { Von nchste CD einlegen }

     end;  { von if ((benutzer_modus=true) and (cd_modus>1)) then }

    { Aktuellen Stand der Dinge reinholen }
    cd_get_status;

  until not cd_eingelegt;       { Und weg, wenn keine CD mehr drinliegt }

 end;

{----------------------------------------}
{ Steuert den normalen Betrieb der Kiste }
{----------------------------------------}
procedure normal_operation;
 begin
  pc_key:=#0;
  while (pc_key=#0) do  { Fr immer ausfhren, solange keine Taste gedrckt wurde }
   begin
    if keypressed then pc_key:=readkey;

    no_cd;             { Noch keine CD im Laufwerk }
    do_cd;             { Solange ien CD im Laufwerk ist.... }

   end;
 end;


{-----------------------------------------------------------------

Bedienung, wenn keine CD eingelegt ist
--------------------------------------

Taste Funktion

1     CD einlegen
2     Laufwerk ffnen/schliessen

Bedienung wenn CD im Laufwerk ist :
------------------------------------

Taste Funktion

1     Play/Pause
2     Stop
3     Skip+
4     Skip-
5     CD+
6     CD-
7     Modus ( Normal, CD wiederholen, Rundum wiederholen

------------------------------------------------------------------

  big_display_buffer_write (6,1,'                          ');
  big_display_buffer_write (12,2,'               ');
  big_display_buffer_write (8,1,'Jukebox (C) Finger 2002');
  big_display_buffer_write (13,2,'Bitte warten !');
  display_light (1);    Licht einschalten
  big_display_refresh;  Text ausgeben

   Seitenlicht animiert einschalten
  write_char_io (7);
  delay (300);
  write_char_io (24+7);
  delay (300);
  write_char_io (96+24+7);
  delay (300);
  write_char_io (255);


   Testen, ob eine CD im Laufwerk ist
  cd_get_status;
  if tuer_offen then
   begin
    writeln ('Schublade offen, wird geschlossen. ');
    cd_close;
    cd_get_status;
   end;

  if cd_eingelegt then
   begin
    writeln ('CD ist eingelegt, mu manuell entfernt werden');
    cd_open;
    big_display_buffer_write (0,10,'Jukebox Finger 2001');
    big_display_buffer_write (6,1,'CD bitte manuell entnehmen');
    big_display_buffer_write (12,2,'dann OK drcken');
    big_display_refresh;
    repeat
     keyboard_getchar;
    until keyboard_key<>0;
   end;


   case ch of
    '1' : begin
            write ('Licht (0..3) : ');readln (wert);
            if keyboard_light (wert) then writeln ('Keyboard Licht geschaltet')
            else writeln ('Keyboardfehler');
          end;
    '2' : begin
           if keyboard_flush then writeln ('Keyboard Puffer leer')
            else writeln ('Keyboardfehler');
          end;
    '3' : begin
            write ('Lock (0/1) : ');readln (wert);
            if keyboard_light (wert) then writeln ('Keyboard Lock geschaltet')
            else writeln ('Keyboardfehler');
          end;
    '4' : begin
           if keyboard_getchar then writeln ('Keyboard gelesen')
            else writeln ('Keyboardfehler');
            writeln ('Empfangenes Zeichen : ',keyboard_key);
          end;



------------------------------------------------------------------}
