Program CDROM_TEST;
uses crt, cdrom;
type a5 = array[0..4] of byte;
var i:byte;
    L : LongInt;
    ch : char;
    no,
    len : integer;

begin
  clrscr;
  Writeln('CDROM-UNIT Testprogram',#10);
  With CD do
  if CD_Avail then
  begin
   writeln (cd_eject);
   writeln (CD_close_tray);

   Writeln(' CD als Laufwerk ',DrvChar,': gefunden!');
   Write  (' Aktuelle CD: ');

   Write('(UPN-CODE:');
   for i := 1 to 7 do write(CHAR( (Upn[i] shr 4)  or $30),
                            CHAR((Upn[i] and $f) or $30));
   writeln(#8')');
   Writeln(' Audio-Tracks : ',loautr,'..',hiautr);
   Writeln(' Laufzeiten : ');
   for i := CD.LoAuTr to CD.HiAuTr do
    with VTOC.Titles[i] do
      writeln(i,Title:10, RunMin:6,':',RunSec);
   no := 1;
   len := -1;

   if CD_Stop then
     if not CD_Play( no ,len)
        then writeln('! Fehler-Status: ',STATUS and $F);

   ch := ' ';
   while ch <> #27 do
   begin
   while ch = ' ' do
     With CD do
     begin
       if CD_Position then
         write('Playing Track ',CTrk,'  :   ',CMin:2,':',CSek:2,'   '#13);
       delay(1500);
       if keypressed
          then ch := readkey;
     end;
     case ch of
       '+' : inc(no);
       '-' : dec(no);
     end;
     if ch <> #27 then ch := ' ';
     if no > cd.HiAUTr then dec(no);
     if no < cd.LoAuTr then inc(no);
     if CD_Stop
       then CD_Play(no, len);
   end;
   cd_stop;
   clreol;
   writeln(' CD stopped...');
  end
  else writeln('Leider kein CD-ROM gefunden...');
end.

Function CD_Open:  Boolean;
Function CD_Close: Boolean;
Function CD_Eject: Boolean;
