{ Hardware bereitmachen }
procedure startup_init;
var testvar : byte;
 begin

  clrscr;
  writeln ('Jukebox 1.0 Copyright Christian Finger 2001'#10#13);

  { Schnittstelle initialisieren }
  { COM1, 9600Bps 8n1 }
  ComInt:=ComInt1;
  Com:=comu1;
  sio_unit_init;
  initcom (9600,8,1,n);

  rescon:=true;
  reset_konverter;

  cd_modus:=1; { Widergabe einfach }
  cd_nummer:=1;

 end;

{ RS485-Hardware feststellen und initialisieren }
procedure RS485_init;
 begin

 { Motortreiber abklappern }
 {-------------------------}
  teller:=motor_identify (adress_teller);
  if not teller then
   fatal_error ('Teller nicht bereit !') else writeln ('Teller gefunden');

  schwenker:=motor_identify (adress_schwenker);
  if not  schwenker then
   fatal_error ('Schwenker nicht bereit !') else writeln ('Schwenker gefunden');

  dreher:=motor_identify (adress_dreher);
  if not dreher then
   fatal_error ('Dreher nicht bereit !') else writeln ('Dreher gefunden');

  greifer:=motor_identify (adress_greifer);
  if not greifer then
   fatal_error ('Greifer nicht bereit !') else writeln ('Greifer gefunden');

   heber:=motor_identify (adress_heber);
  if not heber then
   fatal_error ('Heber nicht bereit !') else writeln ('Heber gefunden');

  { Lampentreiber abklappern }
  {--------------------------}
  lampe_oben_links:=lamp_identify (adress_lampe_top_left);
  if not lampe_oben_links then
   fehler ('Lampe oben links nicht bereit !',false) else
   meldung ('Lampe oben links gefunden');

  lampe_oben_rechts:=lamp_identify (adress_lampe_top_right);
  if not lampe_oben_rechts then
   fehler ('Lampe oben rechts nicht bereit !',false) else
   meldung ('Lampe oben rechts gefunden');

  lampe_mischer_rot:=lamp_identify (adress_mischer_rot);
  if not lampe_mischer_rot then
   fehler ('Mischerlampe rot nicht gefunden',false) else
   meldung ('Mischerlampe rot gefunden');

  lampe_mischer_gruen:=lamp_identify (adress_mischer_gruen);
  if not lampe_mischer_gruen then
   fehler ('Mischerlampe grn nicht gefunden',false) else
   meldung ('Mischerlampe grn gefunden');

  lampe_mischer_blau:=lamp_identify (adress_mischer_blau);
  if not lampe_mischer_blau then
   fehler ('Mischerlampe blau nicht gefunden',false) else
   meldung ('Mischerlampe blau gefunden');

  lampe_mischer_gelb:=lamp_identify (adress_mischer_gelb);
  if not lampe_mischer_gelb then
   fehler ('Mischerlampe gelb nicht gefunden',false) else
   meldung ('Mischerlampe gelb gefunden');

  { Display abklappern }
  {--------------------}
  display:=display_identify (adress_display_big);
  if not display then
   fehler ('Hauptdisplay nicht gefunden !',false) else
   meldung ('Hauptdisplay gefunden');

  { Tastatur abklappern }
  {---------------------}
  keyboard:=keyboard_identify (adress_keyboard);
  if not keyboard then
   fehler ('Keyboard nicht gefunden !',false) else
   meldung ('Keyboard gefunden');

  { IO abklappern }
  {---------------------}
  io:=io_identify (adress_io);
  if not io then
   fehler ('IO nicht gefunden !',false) else
   meldung ('IO gefunden');

  (* ----------*)

   { Harwaregruppen definieren }
   motoren:=(heber or schwenker or greifer or teller or dreher);
   lampen:=(lampe_oben_rechts or lampe_oben_links or lampe_mischer_rot);
   lampen:=(lampen or lampe_mischer_gruen or lampe_mischer_blau or lampe_mischer_gelb);
   displays:=(display);
   ios:=(io);
   keyboards:=(keyboard);

   { Ist berhaupt irgendjemand zu hause ? }
   if not (motoren or lampen or displays or ios or keyboards) then
    fatal_error ('Keine Hardware gefunden !');

  { Schrittpositionen auf Null setzen }
  fillchar (schrittpos [1],sizeof (schrittpos),0);

  { Display initialisieren }
  if displays then big_display_init;

 end;
