
{ IO identifizieren }
function io_identify (adress : byte) : boolean;
 begin
  write_sio_status (adress);    { Adresse der Lampe senden }
  write_sio_status (i_identify);{ Befehl senden }
  write_sio_status ($00);       { Es folgen keine Parameter }

  write_sio_status ($02);       { Es mssen zwei Bytes zurckkommen }

  { Warten auf das Acknowledge vom Display }
  io_identify:=get_acknowledge (adress,i_identify,0);
 end;

{ Schaltet die Lampen im IO (0..255) }
function write_char_io (x : byte) : boolean;
 begin
  write_sio_status (adress_io);    { Adresse senden }
  write_sio_status (i_light);            { Befehl senden }
  write_sio_status ($01);                { Es folgen Parameter }
  write_sio_status (x);                { Es folgen Parameter }

  write_sio_status ($02);       { Es mssen zwei Bytes zurckkommen }

  { Warten auf das Acknowledge vom keyboard }
  rescon:=false;
  write_char_io:=get_acknowledge (adress_io,i_light,0);
  rescon:=true;
 end;

{ Liest den Bewegungsmelder aus }
function io_getchar : boolean;
 begin
  write_sio_status (adress_io);    { Adresse senden }
  write_sio_status (i_sensor);            { Befehl senden }
  write_sio_status ($00);                { Es folgen Parameter }

  write_sio_status ($02);       { Es mssen zwei Bytes zurckkommen }

  { Warten auf das Acknowledge vom IO }
  rescon:=false;
  io_getchar:=get_acknowledge (adress_io,i_sensor,0);
  rescon:=true;

  { Die eventuelle Taste steht jetzt in der Variable "keyboard" }
 end;

