
{ Lampe einschalten }
function lamp_switch (adress,wert : byte) : boolean;
 begin
  write_sio_status (adress);    { Adresse der Lampe senden }
  write_sio_status (l_switch);  { Befehl senden }
  write_sio_status ($01);       { Es folgt ein Parameter }
  write_sio_status (wert);      { Startwert }
  write_sio_status ($02);       { Es mssen zwei Bytes zurckkommen }

  { Warten auf das Acknowledge von der Lampe }
  lamp_switch:=get_acknowledge (adress,l_switch,0);

 end;

{ Lampe absolut dimmen }
function lamp_dimm_absolut (adress,start,stop,time : byte) : boolean;
 begin

  write_sio_status (adress);    { Adresse der Lampe senden }
  write_sio_status (l_dimmabs); { Befehl senden }
  write_sio_status ($03);       { Es folgen drei Parameter }
  write_sio_status (start);      { Startwert }
  write_sio_status (stop);      { Endwert }
  write_sio_status (time);      { Zeit }

  write_sio_status ($02);       { Es mssen zwei Bytes zurckkommen }

  { Warten auf das Acknowledge von der Lampe }
  lamp_dimm_absolut:=get_acknowledge (adress,l_dimmabs,0);

 end;

{ Lampe relativ dimmen }
function lamp_dimm_relative (adress,stop,time : byte) : boolean;
 begin

  write_sio_status (adress);    { Adresse der Lampe senden }
  write_sio_status (l_dimmrel); { Befehl senden }
  write_sio_status ($02);       { Es folgen zwei Parameter }
  write_sio_status (stop);      { Endwert }
  write_sio_status (time);      { Zeit }

  write_sio_status ($02);       { Es mssen zwei Bytes zurckkommen }

  { Warten auf das Acknowledge von der Lampe }
  lamp_dimm_relative:=get_acknowledge (adress,l_dimmrel,0);

 end;

{ Lampe identifizieren }
function lamp_identify (adress : byte) : boolean;
 begin
  write_sio_status (adress);    { Adresse der Lampe senden }
  write_sio_status (l_identify);{ Befehl senden }
  write_sio_status ($00);       { Es folgen keine Parameter }
  write_sio_status ($02);       { Es mssen zwei Bytes zurckkommen }

  { Warten auf das Acknowledge der Lampe }
  lamp_identify:=get_acknowledge (adress,l_identify,0);

 end;